/*****************************************************************
  read_kyoto_corpus.c
  硼ȥѥƤɤߡطʤ¾ˤ롣
******************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define BUFF_MAX 10000
#define BUNS_MAX 50
#define TANGO_MAX 50
#define MOJI_MAX 100

struct {
  int kakarisaki;
  char kakari_type[MOJI_MAX];
  char mark[5];

  struct {
    char word[MOJI_MAX];
    char yomi[MOJI_MAX];
    
    char hins_a[MOJI_MAX];
    char hins_b[MOJI_MAX];
    char hins_c[MOJI_MAX];
    char hins_d[MOJI_MAX];
    char hins_e[MOJI_MAX];
  }tango[TANGO_MAX];
}buns[BUNS_MAX];

/* prototypes */
void disp_structure(int ,FILE *);
void out_4_c45(int,FILE *);

void main(int argc,char **argv)
{
  int i,j,k;
  int bun_num=0;
  int buns_num;
  int tango_num;
  char kakari_num[10];

  char *buff;
  char *ptr;
  

  FILE *fp_in,*fp_out;

  char s_id[50];

  buff = (char *)malloc(BUFF_MAX);
  ptr = (char *)malloc(BUFF_MAX);

  /**************  *****************/
  /*FILE OPEN                              */
  if(argc!= 3 || ((fp_in=fopen(argv[1],"r"))==NULL)
     || ((fp_out=fopen(argv[2],"w"))==NULL)){
    fprintf(stderr,"cannot open \n");
    exit(1);
  }

  /* ڤФ롼 */
  while(fgets(buff,BUFF_MAX,fp_in)!=NULL){
    /* check 
       printf("fgets:>%s\n",buff);*/
    if(buff[0]=='#'){
      bun_num ++;
      strcpy(s_id,buff);
      /* check 
      printf("sentence #%d\n",bun_num);*/
      buns_num = -1;
    }
    else if(buff[0]=='*'){
      buns_num ++;
      buns[buns_num].mark[0]='\0';
      /* ڤФ */
      strcpy(ptr,(strrchr(buff,' ')+strlen(" ")));
      for(i=0;isalpha(ptr[i])==0;i ++)kakari_num[i]=ptr[i];
      kakari_num[i]='\0';
      buns[buns_num].kakarisaki=atoi(kakari_num);
      buns[buns_num].kakari_type[0]=ptr[i];
      buns[buns_num].kakari_type[1]='\0';
      /* check 
      printf("%d to %d(%s)\n"
             ,buns_num,buns[buns_num].kakarisaki
	     ,buns[buns_num].kakari_type);*/
      tango_num = -1;
      buns[buns_num+1].mark[0]='_';
      buns[buns_num+1].mark[1]='\0';

    }
    else if(buff[0]=='E'){
      disp_structure(bun_num,fp_out);
      /*out_4_c45(bun_num,fp_out);*/
    }
    else{
      tango_num ++;
      /* ʸ̤ڤФ */
      for(i=0,j=0;buff[i]!=' ';i ++,j ++){
	buns[buns_num].tango[tango_num].word[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].word[i]='\0';
      i ++;
      /* ɤߤڤФ   */
      for(j=0;buff[i]!=' ';i++,j ++){
      	buns[buns_num].tango[tango_num].yomi[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].yomi[j]='\0';
      i ++;
      /* ʻ         */
      for(j=0;buff[i]!=' ';i++,j ++){
      	buns[buns_num].tango[tango_num].hins_a[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].hins_a[j]='\0';
      i ++;
      for(j=0;buff[i]!=' ';i++,j ++){
      	buns[buns_num].tango[tango_num].hins_b[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].hins_b[j]='\0';
      i ++;
      for(j=0;buff[i]!=' ';i++,j ++){
      	buns[buns_num].tango[tango_num].hins_c[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].hins_c[j]='\0';
      i ++;
      for(j=0;buff[i]!=' ';i++,j ++){
      	buns[buns_num].tango[tango_num].hins_d[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].hins_d[j]='\0';
      i ++;
      for(j=0;buff[i]!='\0';i++,j ++){
      	buns[buns_num].tango[tango_num].hins_e[j]=buff[i];
      }
      buns[buns_num].tango[tango_num].hins_e[j]='\0';
      
      /* check
      printf("tango# %d\ntoken;%s(%s)/%s/%s/%s/%s/%s\nbuff;%s\n",tango_num
	     ,buns[buns_num].tango[tango_num].word
	     ,buns[buns_num].tango[tango_num].yomi
	     ,buns[buns_num].tango[tango_num].hins_a
	     ,buns[buns_num].tango[tango_num].hins_b
	     ,buns[buns_num].tango[tango_num].hins_c
	     ,buns[buns_num].tango[tango_num].hins_d
	     ,buns[buns_num].tango[tango_num].hins_e
	     ,buff);*/

      buns[buns_num].tango[tango_num+1].word[0]='_';
      buns[buns_num].tango[tango_num+1].word[1]='\0';
    }
	
  }

  printf("total %d sentenses\n",bun_num);
  
  fclose(fp_in);
  fclose(fp_out);
  
  exit(0);
}


/* ¤ɽ *************************************/
void disp_structure(int bun_num,FILE *fp)
{
  int i,j,k;

  fprintf(fp,"sentens #%d\n",bun_num);
  /* ʸ롼 */
  for(i=0;buns[i].mark[0]!='_';i ++){
    fprintf(fp,"%2d->%2d(%s):",i,buns[i].kakarisaki,buns[i].kakari_type);
    /* ñ롼 */
    for(j=0;buns[i].tango[j].word[0]!='_';j ++){
      fprintf(fp,"%s/"
	      ,buns[i].tango[j].word);
    }
    fprintf(fp,"\n");
  }
  fprintf(fp,"------------------------------\n");

  /************* ɽ㤽Σ *******************
  for(i=0;buns[i].mark[0]!='_';i ++){
    fprintf(fp,"%d/",i+1);
    for(j=0;buns[i].tango[j].word[0]!='_';j ++){
      fprintf(fp,"%s"
	      ,buns[i].tango[j].word);
    }
    fprintf(fp,"/0/0/0/%d",buns[i].kakarisaki+1);
    fprintf(fp,"\n");
  }
  fprintf(fp,"------------------------------\n");*/


}


void out_4_c45(int bun_num,FILE *fp)
{
  int i,j,k;

  /* ʸ롼 */
  for(i=0;buns[i].mark[0]!='_';i ++){
    /* ʬ롼פΣ */
    for(j=i;buns[j].mark[0]!='_';j ++){
      /* check 
      fprintf(fp,"%d:%s -> %d:%s "
	      ,i,buns[i].tango[0].word,j,buns[j].tango[0].word);*/
      fprintf(fp,"%s,%s,",buns[i].tango[0].hins_b
	                 ,buns[j].tango[0].hins_b);
      if(buns[i].kakarisaki==j)fprintf(fp,"yes\n");
      else fprintf(fp,"no\n");
    }
  }
  
}

