#include "common.h"

#define DEBUGP0 0

#define ERR_NOEXIST  1
#define ERR_PERMIT   2

int   repl1c=0, repl2c=0, file1c=0, file2c=0;

int   doNgram;
int   doRensa;
int   doRisan;
char  project  [81];
char  source   [81];
char  savedir  [81];
char  tempdir  [81];
int   supKakko;
int   repDigit;
int   repQuote;
char  repKakko [81];
char  repDigits[81];
char  repQuotes[81];
int   nocDigit;
int   nocAlpha;
int   nocKana;
uchar  delim   [81];
uchar  skip    [81];

int   renFreq,  LrenFreq;
int   renGram,  LrenGram;
int   renJdosu;
int   renJritu;

int   risComb,  LrisComb;
int   risFreq,  LrisFreq;
int   risGram,  LrisGram;
int   risMode;

char  repl1    [128][11];
char  repl2    [128][11];
char  file1    [128][81];
char  file2    [128][11];

FILE  *inpf, *outf;

void  f0_get_argument();
void  f0_size_check  (int, int, char *);
void  f0_entry_check (int, int, char *);

void  f0_make_p1_2();
void  f0_make_p3();
void  f0_make_p4();
void  f0_make_answer();
void  f0_done_check();

void  f0_error  (char *, char *);
FILE *f0_open   (char *, char *);

/*---------------------------------------------------------------------------*/
void main (int argc, char **argv) {

  if (argc != 3) {
    fprintf(stderr, "usage: %s reqFilename ansFilename\n", argv[0]);
    fflush(stderr);
    exit(1);
  }

  if ((outf = fopen(argv[2], "w")) == NULL) {
    /*--- 󥿥եѥե뤬ʤɤ褦ʤ */
    fprintf(stderr, "\nƥॳ롦顼\n  fopen file=%s\n  errno=%d ",
	    argv[2], errno);
    perror(NULL);
    fflush(stderr);
    exit(0);
  }

  inpf = f0_open(argv[1], "r");
  f0_get_argument();
  if (doNgram) f0_make_p1_2();
  if (doRensa) f0_make_p3();
  if (doRisan) f0_make_p4();

  fprintf(outf, "OK\n");

  fclose(inpf);
  fclose(outf);
  exit(0);
}
/*---------------------------------------------------------------------------*/
void f0_get_argument () {

  char   buf[50001], vals[81], *p;
  int    i, valn, L;

  while (fgets(buf, 50000, inpf) != NULL) {

    buf[strlen(buf)-1] = 0;
    p = strchr(buf, ']');
    *(p) = 0;

    if (buf[11] == 0) {
      vals[0] = 0;
      valn    = 0;
    } else {
      strcpy(vals, &buf[11]);
      valn = atoi(vals);
      for (i=0; i<strlen(vals); i++) {
	if (isdigit(vals[i]) == 0) {
	  valn = -1;
	  break;
	}
      }
    }

    L = strlen(vals);

    if      (strncmp(buf,"doNgram  ",9) == 0) doNgram = valn;
    else if (strncmp(buf,"doRensa  ",9) == 0) doRensa = valn;
    else if (strncmp(buf,"doRisan  ",9) == 0) doRisan = valn;

    else if (strncmp(buf,"project  ",9) == 0) {
      f0_size_check(L, 80, "ץ̾");
      strcpy(project  , vals);
    }
    else if (strncmp(buf,"source   ",9) == 0) {
      f0_size_check(L, 80, "ǡե̾");
      strcpy(source   , vals);

    }
    else if (strncmp(buf,"savedir  ",9) == 0) {
      f0_size_check(L, 80, "¸ǥ쥯ȥ̾");
      strcpy(savedir  , vals);
    }
    else if (strncmp(buf,"tempdir  ",9) == 0) {
      f0_size_check(L, 80, "ȥǥ쥯ȥ̾");
      strcpy(tempdir  , vals);
    }
    else if (strncmp(buf,"supKakko ",9) == 0) supKakko = valn;
    else if (strncmp(buf,"repDigit ",9) == 0) repDigit = valn;
    else if (strncmp(buf,"repQuote ",9) == 0) repQuote = valn;

    else if (strncmp(buf,"repKakko ",9) == 0) {
      f0_size_check(L, 10, "Ѵʸ");
      strcpy(repKakko , vals);
    }
    else if (strncmp(buf,"repDigits",9) == 0) {
      f0_size_check(L, 10, "Ѵʸ");
      strcpy(repDigits, vals);
    }
    else if (strncmp(buf,"repQuotes",9) == 0) {
      f0_size_check(L, 10, "ʸѴʸ");
      strcpy(repQuotes, vals);
    }
    else if (strncmp(buf,"nocDigit ",9) == 0) nocDigit = valn;
    else if (strncmp(buf,"nocAlpha ",9) == 0) nocAlpha = valn;
    else if (strncmp(buf,"nocKana  ",9) == 0) nocKana  = valn;

    else if (strncmp(buf,"delim    ",9) == 0) {
      f0_size_check(L, 80, "ʸ϶ڤʸ");
      strcpy(delim    , vals);
    }
    else if (strncmp(buf,"skip     ",9) == 0) {
      f0_size_check(L, 80, "ɽ϶ػʸ");
      strcpy(skip     , vals);
    }
    else if (strncmp(buf,"renFreq  ",9) == 0) {
      LrenFreq  = L;
       renFreq  = valn;
    }
    else if (strncmp(buf,"renGram  ",9) == 0) {
      LrenGram  = L;
       renGram  = valn;
    }
    else if (strncmp(buf,"renJdosu ",9) == 0) renJdosu = valn;
    else if (strncmp(buf,"renJritu ",9) == 0) renJritu = valn;

    else if (strncmp(buf,"risComb  ",9) == 0) {
      LrisComb  = L;
       risComb  = valn;
    }
    else if (strncmp(buf,"risFreq  ",9) == 0) {
      LrisFreq  = L;
       risFreq  = valn;
    }
    else if (strncmp(buf,"risGram  ",9) == 0) {
      LrisGram  = L;
       risGram  = valn;
    }
    else if (strncmp(buf,"risMode  ",9) == 0) risMode  = valn;

    else if (strncmp(buf,"repl1    ",9) == 0) {
      f0_size_check(L, 10, "ִʸ");
      f0_entry_check(repl1c, 128, "ִʸ");
      strcpy(repl1[repl1c++], vals);
    }
    else if (strncmp(buf,"repl2    ",9) == 0) {
      f0_size_check(L, 10, "ִʸ");
      f0_entry_check(repl2c, 128, "ִʸ");
      strcpy(repl2[repl2c++], vals);
    }
    else if (strncmp(buf,"file1    ",9) == 0) {
      f0_size_check(L, 80, "ִե̾");
      f0_entry_check(file1c, 128, "ִե̾");
      strcpy(file1[file1c++], vals);
    }
    else if (strncmp(buf,"file2    ",9) == 0) {
      f0_size_check(L, 10, "ִʸʥե");
      f0_entry_check(file2c, 128, "ִʸʥե");
      strcpy(file2[file2c++], vals);
    }
  }
}
/*---------------------------------------------------------------------------*/
void  f0_size_check  (int req, int limit, char *msg) {

  char  tmp[256];

  if (req > limit) {
    sprintf(tmp, "%sפʸĹޤʺ %dХȡ", msg, limit);
    f0_error("»", tmp);
  }
}
/*---------------------------------------------------------------------------*/
void  f0_entry_check  (int req, int limit, char *msg) {

  char  tmp[256];

  if (req+1 > limit) {
    sprintf(tmp, "%sפλ꤬¿ޤʺ %dȥ", msg, limit);
    f0_error("»", tmp);
  }
}
/*-----------------------------------------------------------------------------
  p1p2ѥѥ᡼ե
-----------------------------------------------------------------------------*/
void  f0_make_p1_2 () {

  int    i, j;
  char   buf[256];
  FILE  *tmpf;

  if (source[0] == 0)
    f0_error("ǡե̾", "꤬ޤ");

  if ((tmpf = fopen(source, "r")) == NULL)
    f0_error("ǡե̾", "ޤ");

  fclose(tmpf);

  if (delim[0] == 0)
    f0_error("ʸ϶ڤʸ", "꤬ޤ");

  if ((supKakko == 0) && (repKakko[0] != 0))
    f0_error("Ѵ","άΥåޤ");

  if (repDigit && (repDigits[0] == 0))
    f0_error("Ѵ","Ѵʸλ꤬ޤ");

  if ((repDigit == 0) && (repDigits[0] != 0))
    f0_error("Ѵ","ѴΥåޤ");

  if (repQuote && (repQuotes[0] == 0))
    f0_error("Ѵ","ʸѴʸλ꤬ޤ");

  if ((repQuote == 0) && (repQuotes[0] != 0))
    f0_error("Ѵ","ʸѴΥåޤ");

  if (repl1c < repl2c)
    f0_error("ִʸ","ִʸλ꤬ޤ");

  if (repl1c > repl2c)
    f0_error("ִʸ","ִʸλ꤬ޤ");

  if (file1c < file2c)
    f0_error("ִʥե","ե̾λ꤬ޤ");

  if (file1c > file2c)
    f0_error("ִʥե","ִʸλ꤬ޤ");

  for (i=0; i<file1c; i++) {
    if ((tmpf=fopen(file1[i], "r")) == NULL) {
      sprintf(buf, "%s ˥ޤ", file1[i]);
      f0_error("ִʥե", buf);
    }
    fclose(tmpf);
  }

  sprintf(buf, "%s/%s.param.p1", savedir, project);
  tmpf = f0_open(buf, "w");

  fprintf(tmpf, "SOURCE [%s]\n", source);
  fprintf(tmpf, "PROJECT [%s]\n",project );
  fprintf(tmpf, "SAVE [%s]\n",   savedir);

  if (supKakko) fprintf(tmpf, "KAKKO\n");
  if (repDigit) fprintf(tmpf, "DIGIT [%s]\n", repDigits);
  if (repQuote) fprintf(tmpf, "QUOTE [%s]\n", repQuotes);

  for (i=0; delim[i]!=0;) {
    j = fc_type(&delim[i]);
    if (i+j > 128)
      f0_error("»", 
	       "ʸ϶ڤʸפĹޤʺ80Хȡ");
    memcpy(buf, &delim[i], j);
    buf[j] = 0;
    fprintf(tmpf, "DELIM [%s]\n", buf);
    i += j;
  }

  for (i=0; i<repl1c; i++)
    fprintf(tmpf, "REPL [%s] [%s]\n", repl1[i], repl2[i]);

  for (i=0; i<file1c; i++)
    fprintf(tmpf, "FILE [%s] [%s]\n", file1[i], file2[i]);

  fclose(tmpf);

  sprintf(buf, "%s/%s.param.p2", savedir, project);
  tmpf = f0_open(buf, "w");

  fprintf(tmpf, "PROJECT [%s]\n",project );
  fprintf(tmpf, "SAVE [%s]\n",   savedir);
  fprintf(tmpf, "TEMP [%s]\n",   tempdir);

  if (nocDigit) fprintf(tmpf, "DIGIT\n");
  if (nocAlpha) fprintf(tmpf, "ALPHA\n");
  if (nocKana)  fprintf(tmpf, "KANA\n");

  for (i=0; skip[i]!=0;) {
    j = fc_type(&skip[i]);
    if (i+j > 80)
      f0_error("»", 
	       "ɽ϶ػʸפĹޤʺ80Хȡ");
    memcpy(buf, &skip[i], j);
    buf[j] = 0;
    fprintf(tmpf, "SKIP [%s]\n", buf);
    i += j;
  }

  fclose(tmpf);
}
/*-----------------------------------------------------------------------------
  p3ѥѥ᡼ե
-----------------------------------------------------------------------------*/
void  f0_make_p3 () {

  char   path[256];
  FILE  *tmpf;

  if (doNgram == 0) f0_done_check();

  if (LrenFreq == 0)
    f0_error("Ϣо","ٿλ꤬ޤ");

  if (renFreq < 2)
    f0_error("Ϣо",
	     "ٿλ˸꤬ޤ\nʣʾ");

  if (LrenGram == 0)
    f0_error("Ϣо","ʸλ꤬ޤ");

  if (renGram < 2)
    f0_error("Ϣо",
	     "ʸλ˸꤬ޤ\nʣʾ");

  if ((renJdosu < 0) || (renJdosu == 1))
    f0_error("Ϣо",
	     "ٿλ˸꤬ޤ\nʣʾ");

  if (renJritu < 0)
    f0_error("Ϣо",
	     "Ψλ˸꤬ޤ\nʣʾ");

  sprintf(path, "%s/%s.param.p3", savedir, project);
  tmpf = f0_open(path, "w");

  fprintf(tmpf, "PROJECT [%s]\n",project );
  fprintf(tmpf, "SAVE [%s]\n",   savedir);
  fprintf(tmpf, "FREQ [%d]\n",   renFreq);
  fprintf(tmpf, "GRAM [%d]\n",   renGram);
  fprintf(tmpf, "JDOSU [%d]\n",  renJdosu);
  fprintf(tmpf, "JRITU [%d]\n",  renJritu);

  fclose(tmpf);
}
/*-----------------------------------------------------------------------------
  p4ѥѥ᡼ե
-----------------------------------------------------------------------------*/
void  f0_make_p4 () {

  char   path[256];
  FILE  *tmpf;

  if (doNgram == 0) f0_done_check();

  if (LrisComb == 0)
    f0_error("Υо","ȹ礻Ŀλ꤬ޤ");

  if ((risComb < 2) || (risComb > 128))
    f0_error("Υо",
	     "ȹ礻Ŀλ˸꤬ޤ\nʣʾ");

  if (LrisFreq == 0)
    f0_error("Υо", "ٿλ˸꤬ޤ");

  if (risFreq < 2)
    f0_error("Υо",
	     "ٿλ˸꤬ޤ\nʣʾ");

  if (LrisGram == 0)
    f0_error("Υо", "ʸλ˸꤬ޤ");

  if (risGram < 2)
    f0_error("Υо",
	     "ʸλ˸꤬ޤ\nʣʾ");

  sprintf(path, "%s/%s.param.p4", savedir, project);
  tmpf = f0_open(path, "w");

  fprintf(tmpf, "PROJECT [%s]\n",project );
  fprintf(tmpf, "SAVE [%s]\n",   savedir);
  fprintf(tmpf, "COMB [%d]\n",   risComb);
  fprintf(tmpf, "FREQ [%d]\n",   risFreq);
  fprintf(tmpf, "GRAM [%d]\n",   risGram);
  fprintf(tmpf, "YOKU [%d]\n",   risMode);

  fclose(tmpf);
}
/*---------------------------------------------------------------------------*/
void f0_error (char *msg1, char *msg2) {

  fprintf(outf, "ERROR\n%s\n%s\n", msg1, msg2);
  fclose(inpf);
  fclose(outf);
  exit(0);
}
/*---------------------------------------------------------------------------*/
FILE *f0_open  (char *filename, char *mode) {

  static FILE *fp;

  if ((fp = fopen(filename, mode)) != NULL) return(fp);

  fprintf(outf,
	  "ERROR\nƥॳ롦顼\n  fopen file=%s\n  errno=%d\n",
	  filename, errno);
  fclose(inpf);
  fclose(outf);
  exit(0);
}
/*---------------------------------------------------------------------------*/
void f0_done_check () {

  struct stat sbuf;
  char   path[256], msg[256];

  sprintf(path, "%s/%s.zok", savedir, project);

  if (stat(path, &sbuf) == 0) return;

  switch (errno) {
  case ENOENT:
    f0_error("", "Υפ¹ԤƤޤ");
  case EACCES:
    sprintf(msg, "permission %s", path);
    f0_error("SYSTEM", msg);
  default:
    sprintf(msg, "stat %s", path);
    f0_error("SYSTEM", msg);
  }
}
/*---------------------------------------------------------------------------*/
